import type { NobjcObject } from "objc-js";
import type { _NSArray } from "../Foundation/NSArray.js";
import type { _NSCopying } from "../Foundation/NSCopying.js";
import type { _NSDictionary } from "../Foundation/NSDictionary.js";
import type { _NSNumber } from "../Foundation/NSNumber.js";
import type { _NSObject } from "../Foundation/NSObject.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _MTRUnitTestingClusterSimpleStruct } from "./MTRUnitTestingClusterSimpleStruct.js";
export declare class _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams extends _NSObject {
    static alloc(): _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams;
    static new(): _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams;
    init(): _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams;
    /**
     * Initialize an MTRUnitTestingClusterTestComplexNullableOptionalResponseParams with a response-value dictionary of the sort that MTRDeviceResponseHandler would receive. Will return nil and hand out an error if the response-value dictionary is not a command data response or is not the right command response. Will return nil and hand out an error if the data response does not match the known schema for this command.
     */
    initWithResponseValue$error$(responseValue: _NSDictionary, error: NobjcObject | null): _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams | null;
    nullableIntWasNull(): _NSNumber;
    setNullableIntWasNull$(value: _NSNumber): void;
    nullableIntValue(): _NSNumber | null;
    setNullableIntValue$(value: _NSNumber | null): void;
    optionalIntWasPresent(): _NSNumber;
    setOptionalIntWasPresent$(value: _NSNumber): void;
    optionalIntValue(): _NSNumber | null;
    setOptionalIntValue$(value: _NSNumber | null): void;
    nullableOptionalIntWasPresent(): _NSNumber;
    setNullableOptionalIntWasPresent$(value: _NSNumber): void;
    nullableOptionalIntWasNull(): _NSNumber | null;
    setNullableOptionalIntWasNull$(value: _NSNumber | null): void;
    nullableOptionalIntValue(): _NSNumber | null;
    setNullableOptionalIntValue$(value: _NSNumber | null): void;
    nullableStringWasNull(): _NSNumber;
    setNullableStringWasNull$(value: _NSNumber): void;
    nullableStringValue(): _NSString | null;
    setNullableStringValue$(value: _NSString | null): void;
    optionalStringWasPresent(): _NSNumber;
    setOptionalStringWasPresent$(value: _NSNumber): void;
    optionalStringValue(): _NSString | null;
    setOptionalStringValue$(value: _NSString | null): void;
    nullableOptionalStringWasPresent(): _NSNumber;
    setNullableOptionalStringWasPresent$(value: _NSNumber): void;
    nullableOptionalStringWasNull(): _NSNumber | null;
    setNullableOptionalStringWasNull$(value: _NSNumber | null): void;
    nullableOptionalStringValue(): _NSString | null;
    setNullableOptionalStringValue$(value: _NSString | null): void;
    nullableStructWasNull(): _NSNumber;
    setNullableStructWasNull$(value: _NSNumber): void;
    nullableStructValue(): _MTRUnitTestingClusterSimpleStruct | null;
    setNullableStructValue$(value: _MTRUnitTestingClusterSimpleStruct | null): void;
    optionalStructWasPresent(): _NSNumber;
    setOptionalStructWasPresent$(value: _NSNumber): void;
    optionalStructValue(): _MTRUnitTestingClusterSimpleStruct | null;
    setOptionalStructValue$(value: _MTRUnitTestingClusterSimpleStruct | null): void;
    nullableOptionalStructWasPresent(): _NSNumber;
    setNullableOptionalStructWasPresent$(value: _NSNumber): void;
    nullableOptionalStructWasNull(): _NSNumber | null;
    setNullableOptionalStructWasNull$(value: _NSNumber | null): void;
    nullableOptionalStructValue(): _MTRUnitTestingClusterSimpleStruct | null;
    setNullableOptionalStructValue$(value: _MTRUnitTestingClusterSimpleStruct | null): void;
    nullableListWasNull(): _NSNumber;
    setNullableListWasNull$(value: _NSNumber): void;
    nullableListValue(): _NSArray | null;
    setNullableListValue$(value: _NSArray | null): void;
    optionalListWasPresent(): _NSNumber;
    setOptionalListWasPresent$(value: _NSNumber): void;
    optionalListValue(): _NSArray | null;
    setOptionalListValue$(value: _NSArray | null): void;
    nullableOptionalListWasPresent(): _NSNumber;
    setNullableOptionalListWasPresent$(value: _NSNumber): void;
    nullableOptionalListWasNull(): _NSNumber | null;
    setNullableOptionalListWasNull$(value: _NSNumber | null): void;
    nullableOptionalListValue(): _NSArray | null;
    setNullableOptionalListValue$(value: _NSArray | null): void;
    /**
     * Controls whether the command is a timed command (using Timed Invoke). If nil (the default value), a regular invoke is done for commands that do not require a timed invoke and a timed invoke with some default timed request timeout is done for commands that require a timed invoke. If not nil, a timed invoke is done, with the provided value used as the timed request timeout. The value should be chosen small enough to provide the desired security properties but large enough that it will allow a round-trip from the sever to the client (for the status response and actual invoke request) within the timeout window.
     */
    timedInvokeTimeoutMs(): _NSNumber | null;
    setTimedInvokeTimeoutMs$(value: _NSNumber | null): void;
}
export interface _MTRUnitTestingClusterTestComplexNullableOptionalResponseParams extends _NSCopying {
}
